#include <GDIPlus.au3>
#include <GUIConstants.au3>
#include <WIndowsConstants.au3>
#include "MouseSetOnEvent.au3"
#include "CompInfo.au3"
#include <WinAPI.au3>
#include <Misc.au3>
#include <File.au3>
#include <INet.au3>

Opt("GUIOnEventMode", 1)

Global $sPCInfoTool_Version = "1.0"
Global $ExportFile, $SaveDialog, $file, $aOSInfo, $aBIOSInfo
Global $iY = 0

Global $iGUIColorBG = 0xFFFFFFFF
Global $iGUIWidth = 600
Global $iGUIHeight = 800

Global $aPCInformation[22][3]
$aPCInformation[0][0] = 21

Switch @OSArch
	Case "x86"
		$RegType = ""
		$Wow64 = ""
	Case "x64"
		$RegType = "64"
		$Wow64 = "Wow6432Node\"
EndSwitch

$hWnd = GUICreate("PC Info Tool", 600, 400)
GUISetState()

_GDIPlus_Startup()

$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWnd)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iGUIWidth, $iGUIHeight, $hGraphic)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)

$hImageBG = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\BG.png")
$hImageButton1 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Button1.png")
$hImageButton2 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Button2.png")
$hImageButton3 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Button3.png")
$hImageButtonHover1 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\ButtonHover1.png")
$hImageButtonHover2 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\ButtonHover2.png")
$hImageButtonHover3 = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\ButtonHover3.png")

$hFamily = _GDIPlus_FontFamilyCreate("Arial")
$hFont = _GDIPlus_FontCreate($hFamily, 10)
$hFormat = _GDIPlus_StringFormatCreate()

$hBrushText = _GDIPlus_BrushCreateSolid(0xFF8F8F8F)

GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
GUISetOnEvent($GUI_EVENT_RESTORE, "WM_PAINT")
GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, "_Click")
GUIRegisterMsg($WM_PAINT, "WM_PAINT")

Global $aButtons[4][8]
$aButtons[0][0] = 3

$aButtons[1][0] = 130
$aButtons[1][1] = 20
$aButtons[1][2] = 141
$aButtons[1][3] = 32
$aButtons[1][4] = False
$aButtons[1][5] = $hImageButton1
$aButtons[1][6] = $hImageButtonHover1
$aButtons[1][7] = "_ShowCredits"
$aButtons[2][0] = 280
$aButtons[2][1] = 20
$aButtons[2][2] = 141
$aButtons[2][3] = 32
$aButtons[2][4] = False
$aButtons[2][5] = $hImageButton2
$aButtons[2][6] = $hImageButtonHover2
$aButtons[2][7] = "_Export"
$aButtons[3][0] = 130
$aButtons[3][1] = 57
$aButtons[3][2] = 290
$aButtons[3][3] = 32
$aButtons[3][4] = False
$aButtons[3][5] = $hImageButton3
$aButtons[3][6] = $hImageButtonHover3
$aButtons[3][7] = "_MoreInfo"

_SetCoords()
_Update()
_ReDraw()

; Infos als Array
$aPCInformation[1][1] = "Betriebssystem : "
$aPCInformation[2][1] = "Prozessor : "
$aPCInformation[3][1] = "Installierter Arbeitsspeicher : "
$aPCInformation[4][1] = "Systemtyp : "
$aPCInformation[5][1] = "Computername und Arbeitsgruppe : "
$aPCInformation[6][1] = ".NET Framework : "
$aPCInformation[7][1] = "Grafikkarte : "
$aPCInformation[8][1] = "Adobe Flash Version : "
$aPCInformation[9][1] = "IP Adresse : "
$aPCInformation[10][1] = "Servicepack : "
$aPCInformation[11][1] = "Desktop Hhe und Breite : "
$aPCInformation[12][1] = "PC Info Tool Version : "
$aPCInformation[12][0] = $sPCInfoTool_Version
$aPCInformation[13][1] = "Seriennummer : "
$aPCInformation[14][1] = "Installationsdatum : "
$aPCInformation[15][1] = "Hersteller : "
$aPCInformation[16][1] = "Lndercode : "
$aPCInformation[17][1] = "Zeitzone : "
$aPCInformation[18][1] = "Systemsprachcode : "
$aPCInformation[19][1] = "BIOS : "
$aPCInformation[20][1] = "BIOS Version : "
$aPCInformation[21][1] = "BIOS Hersteller : "

HotKeySet("{UP}", "_Up1")
HotKeySet("{DOWN}", "_Down1")
_MouseSetOnEvent($MOUSE_WHEELSCROLLUP_EVENT, "_Up2", "", "", $hWnd)
_MouseSetOnEvent($MOUSE_WHEELSCROLLDOWN_EVENT, "_Down2", "", "", $hWnd)

While Sleep(50)
	$aMousePos = GUIGetCursorInfo($hWnd)
	For $i = 1 To $aButtons[0][0]
		If _PtIsInRect($aMousePos[0], $aMousePos[1] - $iY, $aButtons[$i][0], $aButtons[$i][1], $aButtons[$i][2], $aButtons[$i][3]) Then
			$aButtons[$i][4] = True
		Else
			$aButtons[$i][4] = False
		EndIf
	Next
	_ReDraw()
WEnd

Func _TXTExport()
	$Docs = "::{450D8FBA-AD25-11D0-98A8-0800361B1103}"
	$SaveDialog = FileSaveDialog("Export - Textdatei", $Docs, "Textdatei (*.txt)", 2, "PCInfos.txt")

	If @error Then Return MsgBox(4096, "", "Exportvorgang abgebrochen")
	$ExportFile = FileOpen($SaveDialog, 2)

	If $ExportFile = -1 Then
		MsgBox(0, "Error", "Datei konnte nicht geffnet werden. Exportvorgang abgebrochen.")
	EndIf

	For $i = 1 To $aPCInformation[0][0]
		FileWrite($ExportFile, $aPCInformation[$i][1] & $aPCInformation[$i][0] & @CRLF)
	Next

	FileClose($ExportFile)
EndFunc   ;==>_TXTExport

Func _HTMLExport()
	$Docs = "::{450D8FBA-AD25-11D0-98A8-0800361B1103}"
	$SaveDialog = FileSaveDialog("Export - HTML Datei", $Docs, "HTML Datei (*.html)", 2, "PCInfos.html")
	If @error Then
		MsgBox(4096, "", "Exportvorgang abgebrochen")
		Return 0
	Else
		_FileCreate($SaveDialog)
		$ExportFile = FileOpen($SaveDialog, 2)
		$ExportMuster = FileOpen(@ScriptDir & "\export.html", 0)

		If $ExportFile = -1 Then
			MsgBox(0, "Error", "HTML Datei konnte nicht geffnet werden. Exportvorgang abgebrochen.")
			Return 0
		EndIf

		If $ExportMuster = -1 Then
			MsgBox(0, "Error", "Cant open Export Muster: export.html")
			Return 0
		EndIf

		$Lines = _FileCountLines(@ScriptDir & "\export.html")

		For $i = 1 To $Lines Step 1
			$Text = FileReadLine($ExportMuster, $i)
			$TextReplaced = StringReplace($Text, "(OS)", $aPCInformation[1][0])
			$TextReplaced = StringReplace($TextReplaced, "(Name)", $aPCInformation[5][0])
			$TextReplaced = StringReplace($TextReplaced, "(Datum)", _Date_Time_SystemTimeToDateTimeStr(_Date_Time_GetSystemTime()))
			$TextReplaced = StringReplace($TextReplaced, "(Prozessor)", $aPCInformation[2][0])
			$TextReplaced = StringReplace($TextReplaced, "(RAM)", $aPCInformation[3][0])
			$TextReplaced = StringReplace($TextReplaced, "(Typ)", $aPCInformation[4][0])
			$TextReplaced = StringReplace($TextReplaced, "(Framework)", $aPCInformation[6][0])
			$TextReplaced = StringReplace($TextReplaced, "(Graka)", $aPCInformation[7][0])
			$TextReplaced = StringReplace($TextReplaced, "(AdobeFlash)", $aPCInformation[8][0])
			$TextReplaced = StringReplace($TextReplaced, "(IPNr)", $aPCInformation[9][0])
			$TextReplaced = StringReplace($TextReplaced, "(SPack)", $aPCInformation[10][0])
			$TextReplaced = StringReplace($TextReplaced, "(DesktopData)", $aPCInformation[11][0])
			$TextReplaced = StringReplace($TextReplaced, "(Serial)", $aPCInformation[13][0])
			$TextReplaced = StringReplace($TextReplaced, "(InstallDate)", $aPCInformation[14][0])
			$TextReplaced = StringReplace($TextReplaced, "(Hersteller)", $aPCInformation[15][0])
			$TextReplaced = StringReplace($TextReplaced, "(Landcode)", $aPCInformation[16][0])
			$TextReplaced = StringReplace($TextReplaced, "(Zeitzone)", $aPCInformation[17][0])
			$TextReplaced = StringReplace($TextReplaced, "(Systemsprachcode)", $aPCInformation[18][0])
			$TextReplaced = StringReplace($TextReplaced, "(Bios)", $aPCInformation[19][0])
			$TextReplaced = StringReplace($TextReplaced, "(BiosVer)", $aPCInformation[20][0])
			$TextReplaced = StringReplace($TextReplaced, "(BiosHersteller)", $aPCInformation[21][0])
			$TextReplaced = StringReplace($TextReplaced, "(PCInfoToolVer)", $sPCInfoTool_Version)
			$TextReplaced = StringReplace($TextReplaced, "", "oe")

			FileWrite($ExportFile, $TextReplaced & @CRLF)
		Next
		FileClose($ExportFile)
		FileClose($ExportMuster)
		ShellExecute($SaveDialog)
		Return 1
	EndIf
EndFunc   ;==>_HTMLExport

Func _Update()
	$aRAMInfo = MemGetStats()
	$aPCInformation[3][0] = Round($aRAMInfo[1] / 1024) & " MB"
	$aDotNetFolder = _FileListToArray(RegRead("HKLM" & $RegType & "\Software\Microsoft\.NETFramework", "InstallRoot"), "v*", 2)
	If IsArray($aDotNetFolder) Then
		For $i = 1 To $aDotNetFolder[0]
			For $j = 1 To $aDotNetFolder[0]
				If $i <> $j Then
					If _VersionCompare(StringTrimLeft($aDotNetFolder[$i], 1), StringTrimLeft($aDotNetFolder[$j], 1)) = -1 Then
						$bNewest = $j
						ExitLoop
					EndIf
				EndIf
			Next
		Next
		$aPCInformation[6][0] = StringTrimLeft($aDotNetFolder[$bNewest], 1)
	Else
		$aPCInformation[6][0] = "Nicht vorhanden"
	EndIf
	_ComputerGetOSs($aOSInfo)
	For $i = 1 To $aOSInfo[0][0]
		If $aOSInfo[$i][41] Then
			$aPCInformation[1][0] = StringTrimRight($aOSInfo[$i][0], StringLen($aOSInfo[$i][0]) - StringInStr($aOSInfo[$i][0], "|") + 1)
			$aPCInformation[13][0] = $aOSInfo[$i][46]
			$aPCInformation[14][0] = $aOSInfo[$i][23]
			$aPCInformation[15][0] = $aOSInfo[$i][28]
			$aPCInformation[16][0] = $aOSInfo[$i][6]
			$aPCInformation[17][0] = $aOSInfo[$i][11]
			$aPCInformation[18][0] = $aOSInfo[$i][35]
			ExitLoop
		EndIf
	Next
	_ComputerGetBIOS($aBIOSInfo)
	For $i = 1 To $aBIOSInfo[0][0]
		If $aBIOSInfo[$i][1] = "OK" Then
			$aPCInformation[19][0] = $aBIOSInfo[$i][0]
			$aPCInformation[20][0] = $aBIOSInfo[$i][17]
			$aPCInformation[21][0] = $aBIOSInfo[$i][12]
			ExitLoop
		EndIf
	Next
	$aPCInformation[5][0] = @ComputerName
	$aPCInformation[2][0] = RegRead("HKLM" & $RegType & "\HARDWARE\DESCRIPTION\System\CentralProcessor\0", "processornamestring") & " " & RegRead("HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System\CentralProcessor\0", "Identifier")
	Switch @OSArch
		Case "x86"
			$aPCInformation[4][0] = "32 Bit Version"
		Case "x64"
			$aPCInformation[4][0] = "64 Bit Version"
	EndSwitch
	$sGraDevice = _WinAPI_EnumDisplayDevices("", 0)
	$aPCInformation[7][0] = $sGraDevice[2]
	$aPCInformation[8][0] = StringReplace(RegRead("HKLM" & $RegType & "\SOFTWARE\" & $Wow64 & "Macromedia\FlashPlayer", "CurrentVersion"), ",", ".")
	If $aPCInformation[8][0] = "" Then $aPCInformation[8][0] = "Nicht vorhanden"
	$aPCInformation[9][0] = _GetIP()
	If $aPCInformation[9][0] = -1 Then $aPCInformation[9][0] = @IPAddress1
	$aPCInformation[10][0] = @OSServicePack
	$hWnd_Desktop = _WinAPI_GetDesktopWindow()
	$aPCInformation[11][0] = "Hhe: " & _WinAPI_GetClientHeight($hWnd_Desktop) & "   Breite: " & _WinAPI_GetClientWidth($hWnd_Desktop)
EndFunc   ;==>_Update

Func _ReDraw()
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hImageBG, 0, $iY, $iGUIWidth, $iGUIHeight)
	For $i = 1 To $aButtons[0][0]
		Switch $aButtons[$i][4]
			Case False
				_GDIPlus_GraphicsDrawImageRect($hBuffer, $aButtons[$i][5], $aButtons[$i][0], $aButtons[$i][1] + $iY, $aButtons[$i][2], $aButtons[$i][3])
			Case True
				_GDIPlus_GraphicsDrawImageRect($hBuffer, $aButtons[$i][6], $aButtons[$i][0], $aButtons[$i][1] + $iY, $aButtons[$i][2], $aButtons[$i][3])
		EndSwitch
	Next
	For $i = 1 To 12
		_GDIPlus_GraphicsDrawStringEx($hBuffer, $aPCInformation[$i][0], $hFont, $aPCInformation[$i][2], $hFormat, $hBrushText)
	Next
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $iGUIWidth, $iGUIHeight)
EndFunc   ;==>_ReDraw

Func _Click()
	$aMousePos = GUIGetCursorInfo($hWnd)
	For $i = 1 To $aButtons[0][0]
		If _PtIsInRect($aMousePos[0], $aMousePos[1] - $iY, $aButtons[$i][0], $aButtons[$i][1], $aButtons[$i][2], $aButtons[$i][3]) Then Call($aButtons[$i][7])
	Next
EndFunc   ;==>_Click

Func _ShowCredits()
	MsgBox(64, "Credits", "AutoIt PC Info Tool" & @CRLF & @CRLF & "Mitwirkende:" & @CRLF & @CRLF & "tince (www.autoit.de) - Idee und Design" & @CRLF & "name22 (www.autoit.de) - Funktionen")
EndFunc   ;==>_ShowCredits

Func _Export()
	$hWnd_Export = GUICreate("Exportieren", 145, 105, -1, -1, $WS_SYSMENU)
	$cRadioTXT = GUICtrlCreateRadio("Als .txt exportieren", 10, 5)
	$cRadioHTML = GUICtrlCreateRadio("Als .html exportieren", 10, 25)
	$cButtonOK = GUICtrlCreateButton("Exportieren", 30, 48, 80, 25)
	GUISetState()

	Opt("GUIOnEventMode", 0)

	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				GUIDelete($hWnd_Export)
				Opt("GUIOnEventMode", 1)
				Return 0
			Case $cButtonOK
				Select
					Case BitAND(GUICtrlRead($cRadioTXT), $GUI_CHECKED) = $GUI_CHECKED
						_TXTExport()
					Case BitAND(GUICtrlRead($cRadioHTML), $GUI_CHECKED) = $GUI_CHECKED
						_HTMLExport()
				EndSelect
				GUIDelete($hWnd_Export)
				Opt("GUIOnEventMode", 1)
				Return 1
		EndSwitch
	WEnd
EndFunc   ;==>_Export

Func _MoreInfo()
	$sInfoTmp = ""
	For $i = 1 To $aPCInformation[0][0]
		$sInfoTmp &= $aPCInformation[$i][1] & $aPCInformation[$i][0] & @CRLF
	Next

	$hWnd_MoreInfo = GUICreate("Weitere Informationen", 400, 300)
	$cEditInfo = GUICtrlCreateEdit($sInfoTmp, 0, 0, 400, 300)
	GUICtrlSetFont($cEditInfo, 10)
	GUISetState()

	Opt("GUIOnEventMode", 0)

	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				GUIDelete($hWnd_MoreInfo)
				Opt("GUIOnEventMode", 1)
				Return 1
		EndSwitch
	WEnd
EndFunc   ;==>_MoreInfo

Func _PtIsInRect($iX_Point, $iY_Point, $iX_Rect, $iY_Rect, $iWidth_Rect, $iHeight_Rect)
	If $iX_Point >= $iX_Rect And $iY_Point >= $iY_Rect And $iX_Point <= $iX_Rect + $iWidth_Rect And $iY_Point <= $iY_Rect + $iHeight_Rect Then Return 1
	Return 0
EndFunc   ;==>_PtIsInRect

Func _Up1()
	If $iY < 0 Then
		$iY += 2
		_SetCoords()
		_ReDraw()
	Else
		$iY = 0
		_SetCoords()
		_ReDraw()
	EndIf
EndFunc   ;==>_Up1

Func _Down1()
	If $iY > -$iGUIHeight + 400 Then
		$iY -= 2
		_SetCoords()
		_ReDraw()
	Else
		$iY = -$iGUIHeight + 400
		_SetCoords()
		_ReDraw()
	EndIf
EndFunc   ;==>_Down1

Func _Up2()
	If $iY < 0 Then
		$iY += 20
		_SetCoords()
		_ReDraw()
	Else
		$iY = 0
		_SetCoords()
		_ReDraw()
	EndIf
EndFunc   ;==>_Up2

Func _Down2()
	If $iY > -$iGUIHeight + 400 Then
		$iY -= 20
		_SetCoords()
		_ReDraw()
	Else
		$iY = -$iGUIHeight + 400
		_SetCoords()
		_ReDraw()
	EndIf
EndFunc   ;==>_Down2

Func _SetCoords()
	$aPCInformation[1][2] = _GDIPlus_RectFCreate(30, $iY + 155)
	$aPCInformation[2][2] = _GDIPlus_RectFCreate(30, $iY + 208)
	$aPCInformation[3][2] = _GDIPlus_RectFCreate(30, $iY + 261)
	$aPCInformation[4][2] = _GDIPlus_RectFCreate(30, $iY + 314)
	$aPCInformation[5][2] = _GDIPlus_RectFCreate(30, $iY + 367)
	$aPCInformation[6][2] = _GDIPlus_RectFCreate(30, $iY + 420)
	$aPCInformation[7][2] = _GDIPlus_RectFCreate(30, $iY + 473)
	$aPCInformation[8][2] = _GDIPlus_RectFCreate(30, $iY + 526)
	$aPCInformation[9][2] = _GDIPlus_RectFCreate(30, $iY + 579)
	$aPCInformation[10][2] = _GDIPlus_RectFCreate(30, $iY + 632)
	$aPCInformation[11][2] = _GDIPlus_RectFCreate(30, $iY + 685)
	$aPCInformation[12][2] = _GDIPlus_RectFCreate(30, $iY + 738)
EndFunc   ;==>_SetCoords

Func WM_PAINT()
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, $iGUIWidth, $iGUIHeight)
EndFunc   ;==>WM_PAINT

Func _Exit()
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_ImageDispose($hImageBG)
	_GDIPlus_ImageDispose($hImageButton1)
	_GDIPlus_ImageDispose($hImageButton2)
	_GDIPlus_ImageDispose($hImageButton3)
	_GDIPlus_ImageDispose($hImageButtonHover1)
	_GDIPlus_ImageDispose($hImageButtonHover2)
	_GDIPlus_ImageDispose($hImageButtonHover3)
	_GDIPlus_BrushDispose($hBrushText)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit